#ifndef TF_INCLUDE
#define TF_INCLUDE
//---------------------------------------------

/**************************************************************************\
*                                                                          *
*                                                                          *
*    *****                      *****                                      *
*      *****                  *****                                        *
*        *****              *****                                          *
*          *****          *****                                            *
*            *****      *****                                              *
*              *****  *****                                                *
*            *****      *****                                              *
*          *****          *****          The Firmware.                     *
*        *****              *****        Portable. Compatible.             *
*      *****                  *****      Public Domain.                    *
*    *****                      *****    By NORD><LINK.                    *
*                                                                          *
*                                                                          *
*                                                                          *
*    TF.H   -   Headerfile fuer The Firmware                               *
*                                                                          *
*    angelegt:      DC4OX                                                  *
*    modifiziert:                                                          *
*                                                                          *
*                                                                          *
*                   updated: Sergei Podstrigailo UA9OSV 2003/11/19         *
\**************************************************************************/

#include "l2.h"



/*                                                         Festlegungen   */
/**************************************************************************/

#define MAX_FRAME 2048

#define LOGL1 if(loglevel>0)put_error
#define LOGL2 if(loglevel>1)put_error
#define LOGL3 if(loglevel>2)put_error
#define LOGL4 if(loglevel>3)put_error



#define UTXTLEN     72        /* Anzahl Zeichen maximal im U-Text         */
#define HBUFLEN     256       /* Anzahl Zeichen maximal Hosteingabebuffer */



                              /* "host mode response",                    */
                              /* Hostmodeframe-Antworttypen :             */
#define HMRSUCC     0         /*   "success"                              */
#define HMRSMSG     1         /*   "success message"                      */
#define HMRFMSG     2         /*   "failure message"                      */
#define HMRSTAT     3         /*   "status"                               */
#define HMRMONH     4         /*   "monitor header"                       */
#define HMRMONIH    5         /*   "monitor I frame header"               */
#define HMRMONI     6         /*   "monitor I frame"                      */
#define HMRCONI     7         /*   "connected I frame"                    */



                              /* "host mode state",                       */
                              /* Hostmode-Eingabezustaende :              */
#define HMSCHNL     0         /*   naechstes Eingabebyte ist Kanal        */
#define HMSCMD      1         /*   naechstes Eingabebyte ist Kommando     */
#define HMSLEN      2         /*   naechstes Eingabebyte ist Laenge       */
#define HMSINPUT    3         /*   naechste Eingabebytes sind Eingabetext */



                              /* Zpar-Flags :                             */
#define FZFLOW      0x01      /*   Flow ein                               */
#define FZXONOFF    0x02      /*   XON/XOFF ein                           */



                              /* ASCII-Kontrollzeichen :                  */
#define BELL        0x07      /*   Klingel                                */
#define BS          0x08      /*   Backspace                              */
#define TAB         0x09      /*   Tab                                    */
#define LF          0x0A      /*   Linefeed                               */
#define CR          0x0D      /*   Carriage Return                        */
#define CONTROLR    0x12      /*   DC2                                    */
#define CONTROLU    0x15      /*   NAK                                    */
#define CONTROLX    0x18      /*   CAN                                    */
#define DEL         0x7F      /*   Delete                                 */



                              /* Messagebuffer-Anwahl :                   */
#define MBINFO      0         /*   alle Info-Pakete                       */
#define MBSTATUS    1         /*   alle Statuspakete                      */
#define MBALL       2         /*   alle Pakete                            */



                              /* Flags Mpar :                             */
#define MONI        0x01      /*   I                                      */
#define MONU        0x02      /*   U                                      */
#define MONS        0x04      /*   S                                      */
#define MONC        0x08      /*   C                                      */


short bgetid(unsigned short check,unsigned char *gidp);
void skpvia(void);
void hcrlf(void);
unsigned short mbcnt(LHEAD  *msgl,unsigned short select);
void reset(void);
unsigned char *minmem(void);
unsigned char *maxmem(void);
void sl2par(void);
void l2init(void);
void lxinit(void);
void hputv(unsigned short dmark,unsigned char *vial);
void hputid(unsigned char *id);
void hputs(unsigned char *str);
void hputud(unsigned short u);
unsigned short bgetp(void);
void rsppar(unsigned short par);
void rspiv(unsigned short value);
void rspsuc(void);
void hputc(unsigned char ch);
TF_BOOLEAN nxtnos(void);
void rspex(void);
void rspini(unsigned short r);
void rspipa(void);
void rspexb(void);
void hputcc(unsigned short c);
void rspic(unsigned short c);
void bgetti(unsigned char *p1,unsigned char *p2,unsigned char *p3);
void hputbt(TIMEBL *tbp);
void hpbsb(void);
TF_BOOLEAN invial(unsigned char *vial,unsigned char *id);
TF_BOOLEAN ismonf(MBHEAD *fbp);
void stampb(unsigned char *dtp);
void putnib(unsigned short nibble,MBHEAD *mbp);
void putudc(unsigned short u,MBHEAD *mbp);
void putid(unsigned char *id,MBHEAD *mbp);
void putstr(unsigned char *str,MBHEAD   *mbp);
void putbyt(unsigned short byte,MBHEAD  *mbp);
void putv(unsigned short dmark,unsigned char *vial,MBHEAD *mbp);
void hmputr(unsigned short r);
void hputni(unsigned short nibble);
void hput2d(unsigned char c);
void hputvl(unsigned short dmark,unsigned char *vial);
void hputmb(MBHEAD *mbp);
void hputby(unsigned short byte);
void rspcs(void);
void inilks(void);
short bgetvl(unsigned short check,unsigned char *vial);
void lx(void);
void xonctl(void);
TF_BOOLEAN CONled(TF_BOOLEAN dummy);
TF_BOOLEAN STAled(TF_BOOLEAN dummy);
void selmfl(void);
TF_BOOLEAN ishput(void);
void trpmbb(MBHEAD *mbp);
void frhmon(MBHEAD *fbp);
void cmd(void);
void rspnsc(void);
void tolink(MBHEAD *mbp);
void rsplig(void);
void sttoch(unsigned short msg);
void save_para(void);
void rspnwc(void);
void listch(unsigned short chnl);
void send_kiss(unsigned char type,unsigned char *buf,int len);
void put_error(unsigned char *str);




void append_crc_16(unsigned char *buffer,int *len);
void append_crc_rmnc(unsigned char *buffer,int *len);
int check_crc_16(unsigned char *buffer,int *len);
int check_crc_rmnc(unsigned char *buffer,int *len);
unsigned short int compute_crc(unsigned char *buf, int l);
TF_BOOLEAN ishget(void);
unsigned short hgetc(void);
void delich(void);
void hpinch(unsigned short ch);
void xGcmd(void);
void pushtx(void);
void rspiec(unsigned short c);
void kiss(void);
void rspalc(void);
void rspics(void);
MBHEAD *selmb(LHEAD *msgl,unsigned short select);

void write2kiss(unsigned char *tx_buffer,int len);
void hputfu(unsigned short u);


/* Ende von TF.H */
//-----------------------
#endif

