
#pragma hdrstop
#include <condefs.h>


//---------------------------------------------------------------------------
/*
   tfkiss: TNC-emulation for Linux
   Copyright (C) 1995-96 by Mark Wahl
   Main procedure (main.c)

   created: Mark Wahl DL4YBG 95/09/17
   updated: Mark Wahl DL4YBG 96/10/05
   updated: Berndt Josef Wulf 99/03/12
   updated: mayer hans, oe1smc - 3.6.1999
   updated: mayer hans, oe1smc - 10.7.1999
   updated: mayer hans, oe1smc - 15.8.1999
   updated: Berndt Josef Wulf 99/08/26

   Most of the code for AXIP-mode is taken from the axip-package,
   the copyright notice for this code follows below:
 *
 * Copyright 1991, Michael Westerhof, Sun Microsystems, Inc.
 * This software may be freely used, distributed, or modified, providing
 * this header is not removed.
 *
 *
 * updated: Sergei Podstrigailo UA9OSV 2003/11/19

*/

#include <windows.h>
#include <windowsx.h>
#include <winsock2.h>
//#include <sys/ioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <fcntl.h>
#include<io.h>
#include <conio.h>
#include <sys/stat.h>
//#include <termios.h>
#include <string.h>
#include <time.h>
#include <sys\timeb.h>
#include <sys\types.h>
#include <signal.h>
#include <process.h>
//#include <pwd.h>
//#include <unistd.h>
//#include <netinet/in.h>
//#include <arpa/inet.h>
//#include <sys/un.h>
//#include <netdb.h>
#include "config.h"
#include "dxsoftex.h"



#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef USE_HIBAUD
#include <sys/ioctl.h>
#include <linux/fs.h>
#include <linux/tty.h>
#include <linux/serial.h>
#endif

#define TFKISS_MAIN
#include "all.h"
#include "tf.h"
#include "l2.h"
#include "tfext.h"
#include "kiss.h"
#include "init.h"
#include "version.h"

#ifdef USE_AXIP
//#include <sys/socket.h>
//#include <netinet/in.h>
//#include <netinet/in_systm.h>
//#include <netinet/ip.h>
//#include <netdb.h>
USEUNIT("crc.cpp");
USEUNIT("init.cpp");
USEUNIT("l2a.cpp");
USEUNIT("l2b.cpp");
USEUNIT("l2c.cpp");
USEUNIT("l2d.cpp");
USEUNIT("l2e.cpp");
USEUNIT("l2s.cpp");
USEUNIT("l2v.cpp");
USEUNIT("tfa.cpp");
USEUNIT("tfb.cpp");
USEUNIT("tfc.cpp");
USEUNIT("tfd.cpp");
USEUNIT("tfv.cpp");
USELIB("dxsoftex.lib");
//---------------------------------------------------------------------------
#endif

void dotokiss();

#undef LOOK_OVERRUN

/* memory used for buffers */
#define BUFFERSIZE 327680
/* maximum length of a received frame, The Firmware does not accept more! */
#define MAXFRAMELEN 1+72+256
#define CRCLEN 2
#define MAXKISSLEN MAXFRAMELEN+CRCLEN


int udp_mode;                   /* true if we need a UDP socket */
int ip_mode;                    /* true if we need the raw IP socket */
unsigned short my_udp;          /* the UDP port to use (network byte order) */
unsigned char mycallsign[7];    /* My callsign, shifted ASCII with SSID */
int digi;                       /* True if we are connected to a TNC */
int loglevel;                   /* Verbosity level */

extern char tfkiss_lockfile[];
extern char tfkiss_errfile[];
extern char tfkiss_socket[];
extern char tfkiss_run_dir[];
extern int kisstype;
extern int kiss_active;

#define HOSTQ_BUFLEN 1024
struct hostqueue {
  int first;
  int last;
  unsigned char buffer[HOSTQ_BUFLEN];
  struct hostqueue *next;
};

static struct hostqueue *hostq_root;
static struct hostqueue *hostq_last;
static int hostq_len;

char device[TF_MAXCHAR];
int speed;
int speedflag;
int use_socket=0;
static int terminated;
static int tf_lock;
SOCKET sockfd;
SOCKET consockfd;
static int connected;
//static struct termios org_termios;
//static struct termios wrk_termios;
//static struct termios okbd_termios;
//static struct termios nkbd_termios;
static int rx_state=0;
static short rx_port;
static unsigned char rx_buffer[MAXKISSLEN];
static unsigned char *rx_bufptr;
static int rx_buflen;
static int tx_kick=0;
static short tx_port;
static struct timeb tv;
///static struct timezone tz;
static struct timeb tv_old;
///static struct timezone tz_old;
static unsigned char *buffers;

int tnc_to_kiss = 0 ;

static union {
  struct sockaddr sa;
  struct sockaddr_in si;
  //struct sockaddr_un su;
} addr;


/* defines for rx_state */
#define ST_BEGIN 0
#define ST_PORT 1
#define ST_DATA 2
#define ST_ESC 3

/* special codes used for KISS-protocol */
#define FEND 0xC0
#define FESC 0xDB
#define TFEND 0xDC
#define TFESC 0xDD

#define TTKISS "\033@k\r\n"

static int exit_all();

/* dummy data */
unsigned short p1end;
unsigned short p2strt;

/* warning/error logging */
void put_error(unsigned char *str)
{
  FILE *fp;

  if (!use_socket) {
    fprintf(stderr,"%s\r\n",str);
  }
  else {
      printf("%s\n",str); //my
    if (*tfkiss_errfile != '\0') {
      fp = fopen(tfkiss_errfile,"a+");
      if (fp != NULL) {
        fprintf(fp,"%s\n",str);
        fclose(fp);
      }
    }
  }
}

/* dummy procedures */
void DIinc(void)
{
}

void decEI(void)
{
}

int iscd(int port)
{
  return(FALSE);
}

TF_BOOLEAN CONled(TF_BOOLEAN dummy)
{
  return(FALSE);
}

TF_BOOLEAN STAled(TF_BOOLEAN dummy)
{
  return(FALSE);
}

void xonctl(void)
{
}

void pushtx(void)
{
}

void reset(void)
{
  terminated = 1;
/*
  put_error("reset forced");
  exit_all();
  exit(1);
*/
}

void kiss(void)
{
}

/* real procedures */

unsigned char *minmem(void)
{
  return(buffers);
}

unsigned char *maxmem(void)
{
  return(buffers+BUFFERSIZE-1);
}

/* from buildsaddr.c */
struct sockaddr *build_sockaddr(const unsigned char *name, int *addrlen)
{

  unsigned char *host_name;
  unsigned char *serv_name;
  char buf[1024];

  memset((char *) &addr, 0, sizeof(addr));
  *addrlen = 0;

  host_name = strcpy(buf, name);
  serv_name = strchr(buf, ':');
  if (!serv_name) return 0;
  *serv_name++ = 0;
  if (!*host_name || !*serv_name) return 0;


  addr.si.sin_family = AF_INET;

  if (!strcmp(host_name, "*")) {
    addr.si.sin_addr.s_addr = INADDR_ANY;
  } else if (!strcmp(host_name, "loopback")) {
    addr.si.sin_addr.s_addr = inet_addr("127.0.0.1");
  } else if ((addr.si.sin_addr.s_addr = inet_addr(host_name)) == -1) {
    struct hostent *hp = gethostbyname(host_name);
    ///endhostent();
    if (!hp) return 0;
    addr.si.sin_addr.s_addr = ((struct in_addr *) (hp->h_addr))->s_addr;
  }

  if (isdigit(*serv_name & 0xff)) {
    addr.si.sin_port = htons(atoi(serv_name));
  } else {
    struct servent *sp = getservbyname(serv_name, (char *) 0);
    ///endservent();
    if (!sp) return 0;
    addr.si.sin_port = sp->s_port;
  }

  *addrlen = sizeof(struct sockaddr_in);
  return &addr.sa;
}

void init_console()
{
///  tcgetattr(0,&okbd_termios);
///  nkbd_termios = okbd_termios;
///  nkbd_termios.c_cc[VTIME] = 0;
///  nkbd_termios.c_cc[VMIN] = 1;
///  nkbd_termios.c_cc[VSTART] = -1;
///  nkbd_termios.c_cc[VSTOP] = -1;
///  nkbd_termios.c_iflag = 0;
///  nkbd_termios.c_iflag |= (IGNBRK|ICRNL);
///  nkbd_termios.c_oflag = 0;
///  nkbd_termios.c_lflag = 0;
///  nkbd_termios.c_cflag |= (CS8|CREAD|CLOCAL);
#ifdef HAVE_CRTSCTS
///  nkbd_termios.c_cflag &= ~(CSTOPB|PARENB|PARODD|CRTSCTS|HUPCL);
#else
///  nkbd_termios.c_cflag &= ~(CSTOPB|PARENB|PARODD|HUPCL);
#endif
///  tcsetattr(0,TCSADRAIN,&nkbd_termios);
  hostq_root = NULL;
  hostq_last = NULL;
  hostq_len = 0;
}

void exit_console()
{
  struct hostqueue *hostq_ptr;

  while (hostq_root != NULL) {
    hostq_ptr = hostq_root;
    hostq_root = hostq_ptr->next;
    free(hostq_ptr);
  }
  hostq_last = NULL;
  hostq_len = 0;
///  tcsetattr(0,TCSADRAIN,&okbd_termios);
}

static int init_kisslink(unsigned char *serstr,int speed,
                         int speedflag,int unlock)
{
  if (unlock) unlink(tfkiss_lockfile);
  if ((tf_lock = open(tfkiss_lockfile,O_CREAT|O_EXCL,0600)) == -1) {
    printf("Error: kisslink port locked by other user"
           " or unable to create lockfile\n");
    return(1);
  }

  if(!DxsoftExchangeInit(1))
    {
     printf("Error: DxsoftExchange initialization failed! \n");
     return 1;
    }

  dotokiss() ;

  return(0);
}

//----------------------------------------------------------
static int exit_kisslink()
{
  close(tf_lock);
  unlink(tfkiss_lockfile);
  return(0);
}


static void alloc_hostqbuf()
{
  struct hostqueue *hostq_ptr;

  hostq_ptr = (struct hostqueue *) malloc(sizeof(struct hostqueue));
  if (hostq_ptr == NULL) {
    put_error("malloc failed for hostqueue!");
    exit_all();
    exit(1);
  }
  hostq_ptr->first = 0;
  hostq_ptr->last = 0;
  hostq_ptr->next = NULL;
  if (hostq_root == NULL) {
    hostq_root = hostq_ptr;
  }
  else {
    hostq_last->next = hostq_ptr;
    hostq_last = hostq_ptr;
  }
  hostq_last = hostq_ptr;
}

/* put one character in host-queue */
static void puthostq(unsigned char ch)
{
 static char prev_ch=0;
 struct hostqueue *hostq_ptr;

 if(use_socket)
   {
    if((ch==LF) && (prev_ch==CR))
        {
         prev_ch=ch;
         return; // skip  LF in CR-LF pair
        }
   }

  prev_ch=ch;

  if (hostq_root == NULL) {
    alloc_hostqbuf();
  }
  hostq_ptr = hostq_last;
  if (hostq_ptr->last >= HOSTQ_BUFLEN) {
    alloc_hostqbuf();
    hostq_ptr = hostq_last;
  }
  hostq_ptr->buffer[hostq_ptr->last] = ch;
  hostq_ptr->last++;
  hostq_len++;
}

/* get one character out of host-queue */
static unsigned char gethostq()
{
  struct hostqueue *hostq_ptr;
  unsigned char ch;

  if ((hostq_len == 0) || (hostq_root == NULL)) return(0); /* sanity check */
  hostq_ptr = hostq_root;
  ch = hostq_ptr->buffer[hostq_ptr->first];
  hostq_ptr->first++;
  hostq_len--;
  if ((hostq_ptr->first == hostq_ptr->last) ||
      (hostq_ptr->first == HOSTQ_BUFLEN)) {
    if (hostq_ptr->next == NULL) {
      hostq_root = NULL;
      hostq_last = NULL;
    }
    else {
      hostq_root = hostq_ptr->next;
    }
    free(hostq_ptr);
  }
  return(ch);
}

/* txqueue always empty */
TF_BOOLEAN ishput(void)
{
  return(FALSE);
}

/* send one character to console */
void hputc(unsigned char ch)
{
  int res;

  if (use_socket) {
    putch(ch); //my
    if (connected) {
      while((res = send(consockfd,&ch,1,0))==0);
      if (res == SOCKET_ERROR ) {
        closesocket(consockfd);
        connected = 0;
      }
    }
  }
  else {
    putchar(ch);
  }
}

/* return if character available */
TF_BOOLEAN ishget(void)
{
  if (hostq_len) return(TRUE);
  else return(FALSE);
}

/* get one character from console */
unsigned short hgetc(void)
{
  unsigned char ch;

  ch = gethostq();
  return(ch);
}

/* put received characters in hostbuffer */
static void host_to_queue(unsigned char *buffer,int len)
{
  unsigned char *bufptr;
  int i;

  bufptr = buffer;
  i = 0;
  while (i < len) {
    puthostq(*bufptr);
    i++;
    bufptr++;
  }
}

/* send a command over kisslink */
void send_kisscmd(int cmd,int value)
{
  unsigned char tx_buffer[10];
  unsigned char *tx_bufptr;
  int len;
  unsigned char val2;

  if (!kiss_active) return;
  if (kisstype == KISS_RMNC) return;
  if ((cmd < CMD_TXDELAY) || (cmd > CMD_FULLDUP)) return;
  tx_bufptr = tx_buffer;
  *tx_bufptr++ = FEND;
  *tx_bufptr++ = (unsigned char)cmd;
  len = 2;
  val2 = (unsigned char)(value & 0xFF);
  switch (val2) {
  case FEND:
    *tx_bufptr++ = FESC;
    *tx_bufptr++ = TFEND;
    len += 2;
    break;
  case FESC:
    *tx_bufptr++ = FESC;
    *tx_bufptr++ = TFESC;
    len += 2;
    break;
  default:
    *tx_bufptr++ = val2;
    len++;
    break;
  }
  *tx_bufptr++ = FEND;
  len++;
  write2kiss(tx_buffer,len);
}

/* send all frames in txbuffer over kisslink */
static void kissframe_to_tnc()
{
  unsigned char tx_buffer[1024];
  unsigned char *tx_bufptr;
  int len;
  unsigned short ch1;
  int frame_end;
  int i;
  unsigned char tmp_buffer[MAXKISSLEN];
  unsigned char *tmp_bufptr;
  int tmp_buflen;

  while (tx_kick) {
    tx_kick = 0;
    frame_end = 0;
    tmp_bufptr = tmp_buffer;
    *tmp_bufptr++ = 0x00;
    tmp_buflen = 1;
    while (!frame_end) {
      ch1 = l1get((short)(0x0000 + tx_port * 0x100));
      if (ch1 & 0x8000) {
        frame_end = 1;
        if ((ch1 & 0xFF) != 0x01) {
          tx_kick = 1;
        }
      }
      else {
        *tmp_bufptr++ = (unsigned char)(ch1 & 0xFF);
        tmp_buflen++;
      }
    }
    if (!kiss_active) continue;
    switch (kisstype) {
    case KISS_NORMAL:
      *tmp_buffer = 0x00;
      break;
    case KISS_SMACK:
      *tmp_buffer = 0x80;
      append_crc_16(tmp_buffer,&tmp_buflen);
      break;
    case KISS_RMNC:
      *tmp_buffer = 0x20;
      append_crc_rmnc(tmp_buffer,&tmp_buflen);
      break;
    }
    tx_bufptr = tx_buffer;
    *tx_bufptr++ = FEND;
    len = 1;
    tmp_bufptr = tmp_buffer;
    for (i=0;i<tmp_buflen;i++) {
      switch (*tmp_bufptr) {
      case FEND:
        *tx_bufptr++ = FESC;
        *tx_bufptr++ = TFEND;
        len += 2;
        break;
      case FESC:
        *tx_bufptr++ = FESC;
        *tx_bufptr++ = TFESC;
        len += 2;
        break;
      default:
        *tx_bufptr++ = *tmp_bufptr;
        len++;
        break;
      }
      tmp_bufptr++;
    }
    *tx_bufptr++ = FEND;
    len++;
    write2kiss(tx_buffer,len);
  }
}

/* put received frame into The Firmware buffers */
static void frame_to_l1(unsigned char *buffer,int len)
{
  int i;

  l1put((short)(0x8001 + rx_port * 0x100));
  for (i=0;i<len;i++) {
    l1put((short)(0x0000+(buffer[i]&0xFF)+rx_port*0x100));
  }
  l1put((short)(0x8000 + rx_port * 0x100));
}

static void frame_valid(unsigned char *buffer,int len,int type)
{
  switch (type) {
  case KISS_NORMAL:
    if (len > MAXFRAMELEN)
      put_error("frame too long");
    else
      frame_to_l1(buffer+1,len-1);
    break;
  case KISS_SMACK:
    if (check_crc_16(buffer,&len))
      put_error("SMACK: CRC-error");
    else
      frame_to_l1(buffer+1,len-1);
    break;
  case KISS_RMNC:
    if (check_crc_rmnc(buffer,&len))
      put_error("RMNC: CRC-error");
    else
      frame_to_l1(buffer+1,len-1);
    break;
  }
}

/* put data received over kisslink in rxbuffer */
static void framedata_to_queue(unsigned char *buffer,int len)
{
  unsigned char *bufptr;
  int i;
  unsigned char ch;
  unsigned char tmpstr[MAXCHAR];

  i = 0;
  bufptr = buffer;
  while (i < len) {
    ch = *bufptr;
    switch (rx_state) {
    case ST_BEGIN:
      if (ch == FEND) {
        rx_state = ST_PORT;
      }
      break;
    case ST_PORT:
      /* ignore additional FEND */
      if (ch != FEND) {
        switch (kisstype) {
        case KISS_NORMAL:
          if ((ch & 0x8F) == 0x00) {
            rx_port = (ch & 0x70) >> 4;
          }
          else
            rx_state = ST_BEGIN;
          break;
        case KISS_SMACK:
          if ((ch & 0x8F) == 0x80) {
            rx_port = (ch & 0x70) >> 4;
          }
          else
            rx_state = ST_BEGIN;
          break;
        case KISS_RMNC:
          if ((ch & 0xFF) == 0x20) {
            rx_port = 0;
          }
          else
            rx_state = ST_BEGIN;
          break;
        }
        if (rx_state != ST_BEGIN) {
          /* only port 0 allowed */
          if (rx_port != 0x00) {
            rx_state = ST_BEGIN;
            sprintf(tmpstr,"illegal port received: %d",rx_port);
            put_error(tmpstr);
          }
          else {
            rx_state = ST_DATA;
            rx_bufptr = rx_buffer;
            *rx_bufptr++ = ch;
            rx_buflen = 1;
          }
        }
      }
      break;
    case ST_DATA:
      switch (ch) {
          case FEND:
        frame_valid(rx_buffer,rx_buflen,kisstype);
        rx_state = ST_PORT;
        break;
      case FESC:
        rx_state = ST_ESC;
        break;
      default:
        *rx_bufptr = ch;
        rx_bufptr++;
        rx_buflen++;
        if (rx_buflen > MAXKISSLEN) {
          rx_state = ST_BEGIN;
          put_error("frame too long");
        }
        break;
      }
      break;
    case ST_ESC:
      switch (ch) {
      case TFEND:
        *rx_bufptr = FEND;
        rx_bufptr++;
        rx_buflen++;
        if (rx_buflen > MAXKISSLEN) {
          rx_state = ST_BEGIN;
          put_error("frame too long");
        }
        else
          rx_state = ST_DATA;
        break;
      case TFESC:
        *rx_bufptr = FESC;
        rx_bufptr++;
        rx_buflen++;
        if (rx_buflen > MAXKISSLEN) {
          rx_state = ST_BEGIN;
          put_error("frame too long");
        }
        else
          rx_state = ST_DATA;
        break;
      default:
        rx_state = ST_BEGIN;
        sprintf(tmpstr,"illegal character after FESC: %x",ch);
        put_error(tmpstr);
        break;
      }
      break;
    }
    bufptr++;
    i++;
  }
}

/* there is something in txbuffer */
void kicktx(unsigned char port)
{
  unsigned char tmpstr[MAXCHAR];

  if (port == 0) {
    tx_kick = 1;
  }
  else {
    sprintf(tmpstr,"kicktx on invalid port: %d",port);
    put_error(tmpstr);
  }
}

/* oe1smc */
static void switchback()
{
  exit_all() ;
  exit ( 0 ) ;
}

static void sigterm()
{
  terminated = 1;
  signal(SIGTERM, SIG_IGN);
}

static int exit_all()
{
  free(buffers);

  save_para();

  if (use_socket) {
    if (connected) {
      closesocket(consockfd);
      connected = 0;
    }
    closesocket(sockfd);
  }
  else {
    exit_console();
  }

  exit_proc();

  if (kiss_active) {
    if (exit_kisslink()) {
      return(1);
    }
  }
  return(0);
}

void dotokiss(void)
  {
   printf("do to kiss\n");
  }


int main(int argc,char *argv[])
{
  int len;
  unsigned char buffer[1024];
  int unlock;
  int clilen;
  int servlen;
  struct sockaddr cli_addr;
  struct sockaddr *saddr;
  fd_set rmask;
  struct timeval timevalue;
  int count;

  umask(0); /* don't filter file-permissions */

  buffers = (unsigned char *)malloc(BUFFERSIZE);
  if (buffers == NULL) {
    fprintf(stderr,"malloc for buffers failed\n");
    exit(1);
  }

  if (read_init_file(argc,argv,&unlock)) {
    free(buffers);
    exit(1);
  }

  printf("use_socket=%d\n",use_socket);

  if (kiss_active) {
    if (init_kisslink(device,speed,speedflag,unlock)) {
      free(buffers);
      exit(1);
    }
  }

  if (use_socket) {
    printf("USE SOCKET\n");

    WORD wVersionRequested;
    WSADATA wsaData;
    int err;

    wVersionRequested = MAKEWORD( 2, 0 );

   err = WSAStartup( wVersionRequested, &wsaData );
   if ( err != 0 )

   /* Confirm that the WinSock DLL supports 2.0.*/
   /* Note that if the DLL supports versions greater    */
   /* than 2.0 in addition to 2.0, it will still return */
   /* 2.0 in wVersion since that is the version we      */
   /* requested.                                        */

   if (err || LOBYTE( wsaData.wVersion ) != 2 || HIBYTE( wsaData.wVersion ) != 0 )
    {
     printf("WinSock initialization error! \n");
     WSACleanup( );
     free(buffers);
     if (kiss_active) exit_kisslink();
     exit(1);
    }


     saddr = build_sockaddr(tfkiss_socket,&servlen);
      if (!saddr)
       {
        printf("Invalid definition of socket address\n");
        free(buffers);
        if (kiss_active)
          exit_kisslink();
        WSACleanup( );
        exit(1);
       }

    if ((sockfd = socket(saddr->sa_family,SOCK_STREAM,0)) == INVALID_SOCKET) {
      printf("Can't open stream socket\n");
      free(buffers);
      if (kiss_active)
        exit_kisslink();
      WSACleanup( );
      exit(1);
    }

    if (bind(sockfd,saddr,servlen) < 0) {
      printf("Can't bind socket\n");
      free(buffers);
      if (kiss_active)
        exit_kisslink();
      WSACleanup( );
      exit(1);
    }

    listen(sockfd,5);

    /* printf signon message */
    printf(SIG1);
    printf("%d",LINKNMBR);
    printf(SIG2);
    printf(SIG3);
    printf(SIG4);
    printf(SIG5);
    printf(SIG7);
    printf(SIG8);
    printf(SIG9);
    printf(SIG_D);
    printf(SIG6);


    if (init_proc()) {
      free(buffers);
      closesocket(sockfd);
      if (kiss_active)
        exit_kisslink();
      exit(1);
    }

    ///!!! close(0);
    ///!!! close(1);
    ///!!! close(2);
    //!!!! chdir("/");
    ///!!! setsid();
    ///!!! signal(SIGPIPE, SIG_IGN);
   }
  else
   {
      if (init_proc())
       {
        free(buffers);
        if (kiss_active) exit_kisslink();
        exit(1);
       }
    init_console();
  }

  //!!! signal(SIGHUP, SIG_IGN);
  //!!! signal(SIGTSTP, SIG_IGN);
  //!!! signal(SIGTTIN, SIG_IGN);
  //!!! signal(SIGTTOU, SIG_IGN);
  //!!! signal(SIGTERM, sigterm);
  //!!! signal(SIGUSR1, switchback );  /* oe1smc */

  terminated = 0;
  connected = 0;
  magicn = 0;


  ftime(&tv); ///!!!gettimeofday(&tv,&tz);
  tv_old = tv;
  ///tz_old = tz;

  sl2par();
  l2init();
  lxinit();
  if (!use_socket) {
    /* print signon message */
    hputs(SIG1);
    hputud(LINKNMBR);
    hputs(SIG2);
    hputs(SIG3);
    hputs(SIG4);
    hputs(SIG5);
    hputs(SIG7);
    hputs(SIG8);
    hputs(SIG9);
    hputs(SIG_D);
    hputs(SIG6);
  }

  for (;;) {
    if (terminated) {
      break;
    }

    if(use_socket)
    {
     FD_ZERO(&rmask);
    }

    if (use_socket) {
      if (!connected) {
        FD_SET(sockfd,&rmask);
      }
      else {
        FD_SET(consockfd,&rmask);
      }
    }


    if(use_socket)
    {
      timevalue.tv_usec = 10000;
      timevalue.tv_sec = 0;
      count = select(0,&rmask,(fd_set *) 0,
                   (fd_set *) 0,&timevalue);
      if (count == SOCKET_ERROR) {
        continue;
      }
    }

    if (!use_socket)
      {
          len=0;
          int key;
           while(kbhit())
            {
             key=getch()&255;
             buffer[len++]= (unsigned char)key;
             if(len>1023) break;
             if(key==17) // Ctrl-Q
               {
                magicn=0;
                reset();
                break;
               }
            }
          if (len)
              {
                host_to_queue(buffer,len);
               }
      }


    if (kiss_active)
         {
          len=0;
          int rxsym;
           while((rxsym=DxsoftGetSymFromRxBuffer())!= -1)
            {
             buffer[len++]= (unsigned char)(rxsym&255);
             //printf("<%02x>",rxsym);
             if(len>1023) break;
            }
          if(len)
           {
            framedata_to_queue(buffer,len);
           }
         }

    if (use_socket) {

      if(kbhit())
        {
         if(getch()==17) //Ctrl-Q
           {
            magicn=0;
            reset();
           }
        }

      if (!connected) {
        if (FD_ISSET(sockfd,&rmask)) {
          clilen = sizeof(cli_addr);
          consockfd = accept(sockfd,(struct sockaddr *) &cli_addr,&clilen);
          if (consockfd == INVALID_SOCKET) {
            put_error("Accept error");
          }
          else {
            connected = 1;
            hputs("\r\n*HELLO*\r\n");
          }
        }
      }
      else {
        if (FD_ISSET(consockfd,&rmask)) {
          len = recv(consockfd,buffer,1024,0);
          if ((len == SOCKET_ERROR) || (len == 0)) {
            closesocket(consockfd);
            connected = 0;
          }
          else {
            host_to_queue(buffer,len);
          }
        }
      }
    }

    /* update ticker */
    ftime(&tv); ///!!!!   gettimeofday(&tv,&tz);
    ticks = (((tv.time - tv_old.time) * 100) +
             ((tv.millitm - tv_old.millitm) / 10));

    l2rx();

    newtic = ticks - oldtic;
    oldtic = ticks;
    l2timr(newtic);

    l2tx();
    l2rest();
    lx();
    loops++;

    /* any frames to send? */
    if (tx_kick) {
      kissframe_to_tnc();
    }
    Sleep(10);
  } //  

  if (use_socket) WSACleanup( );

  if (exit_all())
    exit(1);
  else
    exit(0);
}
//---------------------------------------------
void write2kiss(unsigned char *tx_buffer,int len)
{
 while(len--)
   {
    unsigned char txsym= *(tx_buffer++);
    while(!DxsoftPutSymToTxBuffer(txsym)) Sleep(10);
   }
}
//-----------------------------------------------


